> ## Documentation Index
> Fetch the complete documentation index at: https://docs.rated.network/llms.txt
> Use this file to discover all available pages before exploring further.

# Validators APR

This endpoint returns historical data on the returns of a validator index. What's really exciting about this one, is the ability to dig deep into the components of the aggregate return (e.g. returned earned on the execution layer vs the consensus layer etc).

`window` refers to the time window of the aggregation, with `1d`, `7d`, `30d` and `all` being the supported values.

Note: a validator must be active throughout the time window for the value to be produced. For `all` time the last 90 days are considered.


## OpenAPI

````yaml get /v0/eth/validators/{validator_index_or_pubkey}/apr
openapi: 3.1.0
info:
  title: Rated API
  description: >

    Welcome to Rated API Swagger doc for developers! This doc outlines the Rated
    API functionality and API architecture.


    V0: It is separated into seven categories:


    -   **Validators**: Endpoints to query into individual validator indices or
    aggregations of validator indices.

    -   **Operators**: Endpoints to query into pre-materialized operator
    groupings.

    -   **Network**: Endpoints to query into network aggregate stats.

    -   **Slashings**: Endpoints to query into network aggregate stats.

    -   **Withdrawals (beta)**: Endpoints to query into when a withdrawal is
    expected to land.

    -   **Self Report (beta)**: Endpoint to query into all slashed validators
    and individual slashed validator indices


    V1: It is separated into six categories:

    -   **Overview**: Endpoints encapsulating the current status of operators,
    pools and validators.

    -   **Performance**: Endpoints that dive into performance and effectiveness
    metrics on execution and consensus layer for operators, pools and
    validators.

    -   **Rewards**: Endpoints that dive into relevant metrics around rewards
    and penalties for operators, pools and validators.

    -   **Private Sets**: Endpoints that aggregate custom group of validators
    privately for performance and reward drill downs.

    -   **Metadata**: Endpoints that provide metadata about mappings, slashings
    and APRs for validators, pools and operators.

    -   **Network**: Endpoints that provide network level metrics about
    performance, rewards, and distributions.


    [Terms of Use](https://docs.rated.network/legal/terms/api-terms-of-service)


    [API
    Reference](https://docs.rated.network/rated-api/api-reference/introduction)
  version: '1.0'
servers: []
security: []
paths:
  /v0/eth/validators/{validator_index_or_pubkey}/apr:
    get:
      tags:
        - Validators
      summary: Get Apr
      operationId: get_apr_v0_eth_validators__validator_index_or_pubkey__apr_get
      parameters:
        - name: validator_index_or_pubkey
          in: path
          required: true
          schema:
            anyOf:
              - type: integer
                minimum: 0
              - type: string
            title: Validator Index Or Pubkey
        - name: window
          in: query
          required: true
          schema:
            $ref: '#/components/schemas/TimeWindow'
        - name: apr_type
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/AprType'
            default: backward
        - name: X-Rated-Network
          in: header
          required: false
          schema:
            $ref: '#/components/schemas/Network'
            default: mainnet
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ValidatorApr'
        '307':
          description: Validator requested by a valid PubKey
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Bad Request
      security:
        - HTTPBearer: []
components:
  schemas:
    TimeWindow:
      type: string
      enum:
        - 1d
        - 7d
        - 30d
        - all
      title: TimeWindow
    AprType:
      type: string
      enum:
        - backward
        - forward
      title: AprType
    Network:
      type: string
      enum:
        - mainnet
        - hoodi
        - holesky
      title: Network
    ValidatorApr:
      properties:
        id:
          type: integer
          minimum: 0
          title: Id
        idType:
          $ref: '#/components/schemas/IdType'
        timeWindow:
          $ref: '#/components/schemas/TimeWindow'
        aprType:
          $ref: '#/components/schemas/AprType'
        percentage:
          type: number
          title: Percentage
        percentageConsensus:
          type: number
          title: Percentageconsensus
        percentageExecution:
          type: number
          title: Percentageexecution
        activeStake:
          type: number
          title: Activestake
        activeValidators:
          type: integer
          minimum: 0
          title: Activevalidators
      additionalProperties: true
      type: object
      required:
        - id
        - idType
        - timeWindow
        - aprType
        - percentage
        - percentageConsensus
        - percentageExecution
        - activeStake
        - activeValidators
      title: ValidatorApr
      examples:
        - activeStake: 4823520000000000
          activeValidators: 150735
          aprType: backward
          idType: validator
          percentage: 5.35
          percentageConsensus: 4.04
          percentageExecution: 1.31
          timeWindow: all
          validatorIndex: 1000
    ErrorResponse:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/Error'
          type: array
          title: Detail
      type: object
      required:
        - detail
      title: ErrorResponse
    IdType:
      type: string
      enum:
        - depositAddress
        - withdrawalAddress
        - nodeOperator
        - pool
        - poolShare
        - entity
        - validator
        - privateSet
      title: IdType
    Error:
      properties:
        loc:
          anyOf:
            - items:
                type: string
              type: array
            - type: 'null'
          title: Loc
        msg:
          type: string
          title: Msg
        type:
          type: string
          title: Type
      type: object
      required:
        - msg
        - type
      title: Error
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````